
# parsediff.pl -
# generate a list of files to zip, comparing two mame distributions.
# one example of use is:
# diff /cverge.13/src src > distdiff
# perl parsediff.pl < distdiff > ziplist
# zip -@ ../newdist.zip < ziplist
#
# such that cverge.13 is the base distribution and src is the new,
# parsediff.pl is this script, and newdist.zip is the destination filename.
# then use zip taking input from stdin and redirect stdin from the file list.
#

print "*.txt\n";
print "makefile\n";
print "nmake.mak\n";
print "testcv.pl\n";
print "parsediff.pl\n";
print "makedist.bat\n";

while(<STDIN>) {

# Files $A and $B differ
	if ( /Files/ && /and/ && /differ/ ) {
		($lhs,$rhs) = split(' and ');
		$_=$rhs;
		($filename,$fluff) = split(' diff');
		$filename =~ s/ /\\ /g;
		print "$filename\n";
		}

# Only in src...
	if ( /Only in src/ ) {
		($lhs, $rhs) = split(' in src');
		$rhs =~ s/: /\//;
		print "src$rhs";
		}
	}
