
$ln = (0-1);

# $debug=7;

while(<STDIN>) {

	$intercept=0;	# flag to indicate that stdin was intercepted

	$ln++;

	$tmp=$_;

#	if ( /PORT_DIPNAME\ \(/ ) {
#		$_ =~ s/PORT_DIPNAME\ \(/PORT_DIPNAMEMESS\(/;
#		}

#	if ( /PORT_DIPNAME/ ) {
#		$_ =~ s/PORT_DIPNAME/PORT_DIPNAMEMESS/;
#		}

	if ( /struct MachineDriver/ ) {
		if ($debug%1>0) {
			print "// migration trace: at line $ln, pattern 'struct MachineDriver' encountered\n\n";
			}
		print "$tmp";
		$_ = $tmp;
#print "found MachineDriver\n";
		($a,$b) = split (' MachineDriver ');
		$_=$b;
		($name,$chaff)=split('=');
#		print "$name $chaff";
#		print "$a $b";
		$_=$name;
		if ( /_/) {
			($sysname,$chaff)=split('_');
			$name=$sysname;
#			print "sysname: $sysname\n";
			}
		$intercept=1;
		$xit=0;
		$i=0;
		$in=0;
		$commacnt=0;
		$_=<STDIN>;
		$passthrough=0;
		$pass="";
		$singlepass=0;
		$comment=0;
		$incomment=0;
		$quotecount=0;

		while($xit==0) {

			$suppress=0;
			$naoverride=0;
			$cdr=0;

			if ($in==1) {

#				print "\n// migration trace: in==1\n";

				if ( $_ =~ s/,/__sp/ ) {

					if ($incomment==2) {
						$incomment=0;
						}

					($nextarg,$cdr)=split('__sp');

					while($nextarg =~ s/\"/__qu/) {
						$quotecount++;
						if ($nextarg =~ s/\"/__qu/) {
							$quotecount++;
							}
						}

					while($nextarg =~ s/__qu/\"/) {
						if ($nextarg =~ s/__qu/\"/) {
							}
						}

					while($nextarg =~ s/\/\*/__oc/) {
						$incomment=1;
						if ($nextarg =~ s/\*\//__cc/) {
							$incomment=0;
							}
						}

					while($nextarg =~ s/__oc/\/\*/) {
						if ($nextarg =~ s/__cc/\*\//) {
							}
						}

					if ($nextarg =~ s/\/\//\/\//) {
						$incomment = 2;
						}

					if ($quotecount%2==1) {
						if ($debug%2>0) {
							print "\n// migration trace: quotecount mod 2 == 1!\n";
							}
						$incomment=2;
						$suppress=3;
						$naoverride=0;
						}

					if ($incomment==1) {
#						print "\n// migration trace: incomment == 1!\n";
						}

# if comma occurs after comment open mark/flag or an unbalanced quote,
# then don't really count it...

					if ( $quotecount%2==1 || $incomment==1 || $nextarg =~ s/\/\//\/\//) {
#						print "\n// migration trace: comma ignore condition\n";
						$commacnt--;
						}

					if ( $nextarg =~ s/{/{/) {
						$_ =~ s/__sp/,/;
						$suppress=2;
						$naoverride=0;
#						print "here!\n";
						}
					else {
						$suppress=1;
						$naoverride=1;
						$commacnt++;

#						print "nextarg: $nextarg\n";
#						print "cdr: $cdr in: $in\n";

						if ($commacnt==6 && $incomment==0) {
							print "\n// migration trace: at line $ln, commacnt == 6, conditional insertion\n";
							print "\n#ifndef MME\n";
							$stopline=$nextarg;
							if ($cdr =~ s/\/\*/\/\*/) {
								print "$stopline,$cdr";
								$_="#endif\n";
								$suppress=0;
								}
							else {
								print "$stopline,\n#endif\n";
								$naoverride=0;
								}
							}
						if ($commacnt==20 && $incomment==0) {
							print "\n// migration trace: at line $ln, commacnt == 20, conditional alteration\n";
							print "\n#ifndef MME\n0,\n#else\n$stopline,\n#endif\n";
							$naoverride=0;
							}
						}

					if ($nextarg =~ s/\*\//\*\//) {
#						print "// migration trace: found close comment - incomment set to 0\n";
						$incomment=0;
						}

					if ($cdr =~ s/\*\//\*\//) {
#						print "// migration trace: found close comment - incomment set to 0\n";
						$incomment=0;
						}
					}
				}
			else {
#				$holdbuf[$curbuf++]="\n// migration trace: no comma found\n";
				$nextarg=$_;
				while($nextarg =~ s/\"/__qu/) {
					$quotecount++;
#					$holdbuf[$curbuf++]="\n// migration trace: quotecount is $quotecount '$nextarg' \n";
					}

				while($nextarg =~ s/__qu/\"/) {
					;
					}

				while($nextarg =~ s/\/\*/__oc/) {
					$incomment=1;
					if ($nextarg =~ s/\*\//__cc/) {
						$incomment=0;
						}
					}

				while($nextarg =~ s/__oc/\/\*/) {
					if ($nextarg =~ s/__cc/\*\//) {
						}
					}
				}


			if ($_ =~ s/{/{/) {
				$in++;
				$naoverride=1;
				if ($debug%4>0) {
					print "// migration trace: found { - in is $in - suppress is $suppress\n";
					}
				}

			if ($_ =~ s/}/}/) {
				$in--;
				if ($debug%4>0) {
					print "// migration trace: found } - in is $in!\n";
					}
				}

			if ( ($suppress == 2 || $suppress == 0) && $_ =~ s/}/__cl/ ) {
				($car,$cdr)=split('__cl');
 				print "$car}";
 				$suppress=1;
 				$naoverride=0;
				$_=~s/__cl/}/;
				}

			if ($suppress==0 && $quotecount%2==0) {
				print "$_";
				$_ = <STDIN>;
				$ln++;
				}
			else {
				if ($naoverride==0) {
					$_ = $cdr;
					}
				else {
#					print "_:$commacnt:$nextarg,";
					print "$nextarg,";
					$_ = $cdr;
					}
				}

			if ($in<1) {
				$xit=1;
				if ($suppress==1 && $naoverride==0) {
					print "$cdr";
					}
				}
			}
		}


	if ( /struct GameDriver/ ) {
		$holdbuf[0]="// migration trace: at line $ln, pattern 'struct GameDriver' encountered\n\n";
		$holdbuf[1]=$_;
#		print "found GameDriver\n";
		($a,$b) = split (' GameDriver ');
		$_=$b;
		($name,$chaff)=split('=');
#		print "$name $chaff";
#		print "$a $b";
		$_=$name;
		if ( /_/) {
			($sysname,$chaff)=split('_driver');
			$name=$sysname;
#			print "sysname: $sysname\n";
			}
		$intercept=1;
		$xit=0;
		$i=0;
		$in=0;
		$commacnt=0;
		$_=<STDIN>;
		$passthrough=0;
		$pass="";
#		$curbuf=0;
		$curbuf=2;
		$singlepass=0;
		$comment=0;
		$incomment=0;
		$quotecount=0;

		while($xit==0) {

#			$holdbuf[$curbuf++]="\n// migration trace: at head of xit loop, reset of suppress from $suppress\n";

			$suppress=0;
			$naoverride=0;
			$cdr=0;

			if ($in==1) {
			
				if ( $_ =~ s/,/__sp/ ) {

#					$holdbuf[$curbuf++]="\n// migration trace: comma found\n";

					if ($incomment==2) {
						$incomment=0;
						}

					($nextarg,$cdr)=split('__sp');

					while($nextarg =~ s/\"/__qu/) {
						$quotecount++;
#						$holdbuf[$curbuf++]="\n// migration trace: quotecount is $quotecount '$nextarg' \n";
						}

					while($nextarg =~ s/__qu/\"/) {
						;
						}

					while($nextarg =~ s/\/\*/__oc/) {
						$incomment=1;
						if ($nextarg =~ s/\*\//__cc/) {
							$incomment=0;
							}
						}

					while($nextarg =~ s/__oc/\/\*/) {
						if ($nextarg =~ s/__cc/\*\//) {
							}
						}

					if ($nextarg =~ s/\*\//\*\//) {
						$incomment=0;
						}

					if ($nextarg =~ s/\/\//\/\//) {
						$incomment = 2;
						}

					if ($quotecount%2==1) {
#						$holdbuf[$curbuf++]="\n// migration trace: quotecount mod 2 == 1!\n";
						$incomment=2;
						$suppress=1;
						$naoverride=0;
						}

# if comma occurs after comment open mark/flag or unbalanced quote,
# then don't really count it...

					if ( $quotecount%2==1 || $incomment!=0 || $nextarg =~ s/\/\//\/\//) {
						$commacnt--;
						if ($debug%4>0) {
							$holdbuf[$curbuf++]="// migration trace: commacnt decrement: commacnt==$commacnt, incomment is $incomment\n\n";
							}
						}

					if ( $nextarg =~ s/{/{/) {
						$_ =~ s/__sp/,/;
						$suppress=2;
						$naoverride=0;
#						print "here!\n";
						}
					else {
						$suppress=1;
						$naoverride=1;
						$commacnt++;
						if ($debug%4>0) {
							$holdbuf[$curbuf++]="//migration trace: commacnt increment! $commacnt\n";
							}


#						print "nextarg: $nextarg\n";
#						print "cdr: $cdr in: $in\n";

						if ($commacnt==8 && $incomment==0) {
							$holdbuf[$curbuf++]="\n// migration trace: at line $ln, commacnt == 8, conditional alteration\n";
							$holdbuf[$curbuf++]="#ifndef MME\n";
							$holdbuf[$curbuf++]="$nextarg,\n#else\n\&$name\_console,\n#endif\n";
							$naoverride=0;
							}

						if ($commacnt==12 && $incomment==0) {
#							print "\n// migration trace: at line $ln, commacnt == 12, conditional insertion\n";
#							print "\n#ifndef MME\n";
							$holdbuf[$curbuf++]="\n// migration trace: at line $ln, commacnt == 12, conditional insertion\n";
							$holdbuf[$curbuf++]="\n#ifndef MME\n";
							$startconsole=$curbuf;
							$stopline=$nextarg;
#							print "$stopline,\n";
#							print "#endif\n";
							$holdbuf[$curbuf++]="$stopline,\n";
#							$holdbuf[$curbuf++]="#endif\n";
							$naoverride=0;
							}
						if ($commacnt==18 && $incomment==0) {
#							print "\n// migration trace: at line $ln, commacnt == 18, conditional insertion\n";
#							print "\n#ifndef MME\n0,\n#else\n$stopline,\n#endif\n";
							$holdbuf[$curbuf++]="$nextarg";
							$endconsole=$curbuf;
							$speccdr=$cdr;
							$holdbuf[$curbuf++]=",$cdr\n";
							$holdbuf[$curbuf++]="// migration trace: at line $ln, commacnt == 18, conditional insertion\n";
							$_ = "#endif\n";
							$suppress=0;
							}
						if ($commacnt==29 && $incomment==0) {
#							print "\n// migration trace: at line $ln, commacnt == 18, conditional insertion\n";
#							print "\n#ifndef MME\n0,\n#else\n$stopline,\n#endif\n";
							$holdbuf[$curbuf++]="$nextarg\n";
							$_ ="// migration trace: at line $ln, commacnt == 29, trailing comma clip \n";
							$suppress=0;
							}

						if ($cdr =~ s/\*\//\*\//) {
#							print "// migration trace: found close comment - incomment set to 0\n";
							$incomment=0;
							}

						if ($nextarg =~ s/\*\//\*\//) {
#							print "// migration trace: found close comment - incomment set to 0\n";
							$incomment=0;
							}
						}
					}
				else {
#					$holdbuf[$curbuf++]="\n// migration trace: no comma found\n";
					$nextarg=$_;
					while($nextarg =~ s/\"/__qu/) {
						$quotecount++;
#						$holdbuf[$curbuf++]="\n// migration trace: quotecount is $quotecount '$nextarg' \n";
						}

					while($nextarg =~ s/__qu/\"/) {
						;
						}

					while($nextarg =~ s/\/\*/__oc/) {
						$incomment=1;
						if ($nextarg =~ s/\*\//__cc/) {
							$incomment=0;
							}
						}

					while($nextarg =~ s/__oc/\/\*/) {
						if ($nextarg =~ s/__cc/\*\//) {
							}
						}
					}
				}


			if ( /{/) {
#				print "found {!\n";
				$in++;
				}

			if (/}/) {
				$in--;
				}

			if ( ($suppress == 2 || $suppress == 0) && $_ =~ s/}/__cl/ ) {
				($car,$cdr)=split('__cl');
# 				print "$car}";
 				$holdbuf[$curbuf++]="$car}";
 				$suppress=1;
 				$naoverride=0;
				$_=~s/__cl/}/;
				}

			if ($debug%4>0) {
				$holdbuf[$curbuf++]="\n// migration trace: suppress is $suppress, naoverride is $naoverride, commacnt is $commacnt, quotecount is $quotecount, incomment is $incomment\n";
				}

			if ($suppress==0) {
#				print "$_";
				$holdbuf[$curbuf++]="$_";
				$_ = <STDIN>;
				$ln++;
				}
			else {
				if ($naoverride==0) {
					$_ = $cdr;
					}
				else {
#					print "_:$commacnt:$nextarg,";
#					print "$nextarg,";
					$holdbuf[$curbuf++]="$nextarg,";
					$_ = $cdr;
					}
				}

			if ($in<1) {
				$xit=1;
				if ($suppress==1 && $naoverride==0) {
#					print "$cdr";
					$holdbuf[$curbuf++]="$cdr";
					}
				}
			}

		$i=0;
		print "#ifdef MME\n";
		print "struct ConsoleDriver $name\_console = {\n";
		while($i<($endconsole-$startconsole)) {
			print "$holdbuf[$startconsole+$i]";
			$i++;
			}
		print "$speccdr\n";
		print "};\n";
		print "#endif\n\n\n";
		$i=0;
		while($i<$curbuf) {
			print "$holdbuf[$i]";
			$i++;
			}
		}

	if ($intercept==0) {
		print "$_";
		}
	}


