
while(<STDIN>) {
	$outpflag=0;	# if output is parsed and sent, set this to 1
	$_ =~ s/ifdef/!ifdef/;
	$_ =~ s/ifeq/!ifeq/;
	$_ =~ s/ifndef/!ifndef/;
	$_ =~ s/endif/!endif/;
	$_ =~ s/else/!else/;
	$_ =~ s/\$\(subst /\(subst /;
	$_ =~ s/	//;
	$_ =~ s/\t//;
	$_ =~ s/\t//;
	$_ =~ s/\t//;
	$_ =~ s/\t//;
	$_ =~ s/\t//;
	$_ =~ s/\t//;

	if ( /\+=/ ) {
		($a,$b)=split('\+=');

# if a # in the lhs ($a), probably a comment; skip processing for this line
# do not use a # in your lhs unless you want the preprocessor to treat
# the line as a comment

		if ($a =~ /#/) {
			;
			}
		else {
# get rid of lots of spaces, if they exist
			$a =~ s/ //;
			print "$a = \$\($a\) $b";
			$outpflag=1;
			}
		}

	if ( /\# BEGIN STRIP/ ) {

# print blank lines to keep line numbering isomorphic between original makefile
# and generated one, just for ease of sanity and consistency

		print "\n";
		$xit=0;
		while( ($xit==0) ) {
			$_ = <STDIN> ;
			if ( /\# END STRIP/ ) {
				$xit=1;
				}
			else {
				print "\n";
				}
			}
		}

# if CPU= line, eliminate all uses of $ (should be 3...)
	if ( /^CPU=\$\(/ ) {
		print "!undef CPU\n";
		$_ =~ s/\$//;
		$_ =~ s/\$//;
		$_ =~ s/\$//;
		$_ =~ s/\(CPUS\)/\$CPUS/;
		}

	if ( /^SOUND=\$\(/ ) {
		print "!undef SOUND\n";
		$_ =~ s/\$//;
		$_ =~ s/\$//;
		$_ =~ s/\$//;
		$_ =~ s/\(SOUND\)/\$SOUND/;
		}

# rip out sort entirely
	if ( /\$\(sort \$\(/ ) {
		$_ =~ s/\$//;
		$_ =~ s/\(//;
		$_ =~ s/\)//;
		$_ =~ s/sort//;
		}

	if ( /^ifneq/ ) {
# eliminate the (hopefully :) single $ and comma in this line
		$_ =~ s/\$//;
		$_ =~ s/\,//;
		$_ =~ s/\(//;
		$_ =~ s/\(//;
		$_ =~ s/\)//;
		$_ =~ s/\)//;
		($a,$b)=split(' ');
		print "!ifdef $b\n";
		$outpflag=1;
		}

	if ($outpflag==0) {
		print "$_";
		}
	} ;

